-- *************************************************************************
-- DISCLAIMER. THIS SOFTWARE WAS WRITTEN BY EMPLOYEES OF THE U.S.
-- GOVERNMENT AS A PART OF THEIR OFFICIAL DUTIES AND, THEREFORE, IS NOT
-- PROTECTED BY COPYRIGHT. HOWEVER, THIS SOFTWARE CODIFIES THE FINALIST
-- CANDIDATE ALGORITHMS (i.e., MARS, RC6tm, RIJNDAEL, SERPENT, AND
-- TWOFISH) IN THE ADVANCED ENCRYPTION STANDARD (AES) DEVELOPMENT EFFORT
-- SPONSORED BY THE NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY (NIST)
-- AND MAY BE PROTECTED BY ONE OR MORE FORMS OF INTELLECTUAL PROPERTY. THE
-- U.S. GOVERNMENT MAKES NO WARRANTY, EITHER EXPRESSED OR IMPLIED,
-- INCLUDING BUT NO LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY
-- OR FITNESS FOR A PARTICULAR PURPOSE, REGARDING THIS SOFTWARE. THE U.S.
-- GOVERNMENT FURTHER MAKES NO WARRANTY THAT THIS SOFTWARE WILL NOT
-- INFRINGE ANY OTHER UNITED STATES OR FOREIGN PATENT OR OTHER
-- INTELLECTUAL PROPERTY RIGHT. IN NO EVENT SHALL THE U.S. GOVERNMENT BE
-- LIABLE TO ANYONE FOR COMPENSATORY, PUNITIVE, EXEMPLARY, SPECIAL,
-- COLLATERAL, INCIDENTAL, CONSEQUENTIAL, OR ANY OTHER TYPE OF DAMAGES IN
-- CONNECTION WITH OR ARISING OUT OF COPY OR USE OF THIS SOFTWARE.
-- *************************************************************************

-- ===========================================================================
-- File Name : EXPANSION_BLOCK.vhdl
-- Author    : NSA
-- Date      : December 1999
-- Project   : RIJNDAEL 
-- Purpose   : This block serves as a wrapper for the expansion function
--             in the synthesis process
-- Notes     :   
-- ===========================================================================

library IEEE;
library ieee;
use IEEE.std_logic_1164.all;
use WORK.rijndael_pack.all;

entity EXPANSION_BLOCK is
  port (
    cv_in               : in SLV_256;   -- cryptovariable input bus
    cv_size             : in SLV_2;     -- cryptovariable size selection
    round               : in SLV_6;     -- current round of the algorithm
    w_in                : in W_TYPE;    -- W register input
    EXPANSION_FUNCT_out : out W_TYPE    -- expanded output (next W reg. values)
  );
end EXPANSION_BLOCK;

architecture rtl of EXPANSION_BLOCK is 

  signal EXPANSION_FUNCT_out_tmp_created_by_csl : W_TYPE;

begin

    EXPANSION_FUNCT_out_tmp_created_by_csl <=
    EXPANSION_FUNCT(
	cv_in => cv_in,
	cv_size => cv_size,
	round => round,
	w_in => w_in);
    EXPANSION_FUNCT_out <= EXPANSION_FUNCT_out_tmp_created_by_csl ;

end rtl;

